// Copyright (C) 2012 Stefan Prey
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
// 
// 
// This file is part of kanonprogramme.
// 
// kanonprogramme is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// kanonprogramme is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with kanonprogramme.  If not, see <http://www.gnu.org/licenses/>.
// 
// Diese Datei ist Teil von kanonprogramme.
// 
// kanonprogramme ist Freie Software: Sie koennen es unter den Bedingungen
// der GNU General Public License, wie von der Free Software Foundation,
// Version 3 der Lizenz oder (nach Ihrer Option) jeder spaeteren
// veroeffentlichten Version, weiterverbreiten und/oder modifizieren.
// 
// kanonprogramme wird in der Hoffnung, dass es nuetzlich sein wird, aber
// OHNE JEDE GEWAEHELEISTUNG, bereitgestellt; sogar ohne die implizite
// Gewaehrleistung der MARKTFAEHIGKEIT oder EIGNUNG FUER EINEN BESTIMMTEN ZWECK.
// Siehe die GNU General Public License fuer weitere Details.
// 
// Sie sollten eine Kopie der GNU General Public License zusammen mit diesem
// Programm erhalten haben. Wenn nicht, siehe <http://www.gnu.org/licenses/>.
#include "einzelstimme.h"

int einzelstimme::m_schon_eine_instanz = 0;

einzelstimme::einzelstimme(lilypond_datei& datei, int mittelwert) : m_datei(datei)
{
    m_datei << "\\new Staff { ";
    m_datei << "\\set Staff.midiInstrument = #\"string ensemble 1\"  ";
    if(mittelwert >= 0)
	m_datei << "\\clef treble ";
    else
	m_datei << "\\clef bass ";
    m_datei << "\\time 2/2 ";
    if(m_schon_eine_instanz == 0)
    {
      m_datei << "    \\set Score.tempoHideNote = ##t" << endl;
      m_datei << "    \\tempo 1 = " << tempo << endl;
      m_schon_eine_instanz = 1;
    }
}

einzelstimme::~einzelstimme()
{
    m_datei << "\\bar \"||\" }" << endl;
}

void einzelstimme::ton(int ton_t)
{
// -2 entspricht dem kleinen a

    int oktave;
    if(ton_t >= 0)
	oktave = ton_t / 7;
    else
	oktave = (ton_t - 6) / 7;
    int ton_ueber_a = (ton_t >= 2 ? ((ton_t + 2) % 7) : (6 - ((-ton_t + 4) % 7)));
    m_datei << char('a' + ton_ueber_a);
    if(oktave >= 0)
	for(int i = 0; i < oktave + 1; i++)
	    m_datei << "\'";
    else if(oktave < -1)
	for(int i = 0; i > oktave + 1; i--)
	    m_datei << ",";

    m_datei << "1 "; // Dauer
}

void einzelstimme::pause()
{
    m_datei << "R1 ";
}

void einzelstimme::pausen(int p)
{
    for(int i = 0; i < p; i++)
	pause();
}

