// Copyright (C) 2012 Stefan Prey
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
// 
// 
// This file is part of kanonprogramme.
// 
// kanonprogramme is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// kanonprogramme is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with kanonprogramme.  If not, see <http://www.gnu.org/licenses/>.
// 
// Diese Datei ist Teil von kanonprogramme.
// 
// kanonprogramme ist Freie Software: Sie koennen es unter den Bedingungen
// der GNU General Public License, wie von der Free Software Foundation,
// Version 3 der Lizenz oder (nach Ihrer Option) jeder spaeteren
// veroeffentlichten Version, weiterverbreiten und/oder modifizieren.
// 
// kanonprogramme wird in der Hoffnung, dass es nuetzlich sein wird, aber
// OHNE JEDE GEWAEHELEISTUNG, bereitgestellt; sogar ohne die implizite
// Gewaehrleistung der MARKTFAEHIGKEIT oder EIGNUNG FUER EINEN BESTIMMTEN ZWECK.
// Siehe die GNU General Public License fuer weitere Details.
// 
// Sie sollten eine Kopie der GNU General Public License zusammen mit diesem
// Programm erhalten haben. Wenn nicht, siehe <http://www.gnu.org/licenses/>.

#include <iostream>
#include <fstream>
using namespace std;

char* ton_name[] = {"c", "d", "e", "f", "g", "a", "h"};

#include "klang.h"

const int klang::c_akkord;
const int klang::d_akkord;
const int klang::e_akkord;
const int klang::f_akkord;
const int klang::g_akkord;
const int klang::a_akkord;
const int klang::h_akkord;

void klang::versetze(int stufen)
{
    stufen %= oktave_in_stufen;
    if(stufen < 0)
	stufen += oktave_in_stufen;
    m_wert <<= stufen;
    int zwischenwert = m_wert & 0x3f80;
    m_wert &= 0x7f;
    zwischenwert >>= oktave_in_stufen;
    m_wert |= zwischenwert;
}

klang klang::schnittmenge(const klang& rechter_operand)
{
    return klang(m_wert & rechter_operand.m_wert);
}

void klang::ausgabe(ostream& file)
{
    klang test_akkord(c_akkord);
    for(int i = 0; i < oktave_in_stufen; i++, test_akkord.versetze(1))
	if(passt_zu(test_akkord))
	    file << ton_name[i] << " ";
    file << endl;
}
