// Copyright (C) 2012 Stefan Prey
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
// 
// 
// This file is part of kanonprogramme.
// 
// kanonprogramme is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// kanonprogramme is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with kanonprogramme.  If not, see <http://www.gnu.org/licenses/>.
// 
// Diese Datei ist Teil von kanonprogramme.
// 
// kanonprogramme ist Freie Software: Sie koennen es unter den Bedingungen
// der GNU General Public License, wie von der Free Software Foundation,
// Version 3 der Lizenz oder (nach Ihrer Option) jeder spaeteren
// veroeffentlichten Version, weiterverbreiten und/oder modifizieren.
// 
// kanonprogramme wird in der Hoffnung, dass es nuetzlich sein wird, aber
// OHNE JEDE GEWAEHELEISTUNG, bereitgestellt; sogar ohne die implizite
// Gewaehrleistung der MARKTFAEHIGKEIT oder EIGNUNG FUER EINEN BESTIMMTEN ZWECK.
// Siehe die GNU General Public License fuer weitere Details.
// 
// Sie sollten eine Kopie der GNU General Public License zusammen mit diesem
// Programm erhalten haben. Wenn nicht, siehe <http://www.gnu.org/licenses/>.
#include "StdAfx.h"
#include "einsatzschema.h"

einsatzschema::einsatzschema(int n) : m_anzahl_stimmen(n)
{
    m_die_stimmen = new stimme [m_anzahl_stimmen];
    if(m_die_stimmen == NULL)
	exit(1);
}

einsatzschema::~einsatzschema()
{
    delete[] m_die_stimmen;
}

void einsatzschema::einfuegen(int nummer, const stimme& ausgangsstimme)
{
    m_die_stimmen[nummer] = ausgangsstimme;
}

int einsatzschema::get_stimme_rhythmischer_abstand(int n)
{
    return m_die_stimmen[n].get_rhythmischer_abstand();
}

int einsatzschema::get_stimme_intervallischer_abstand(int n)
{
    return m_die_stimmen[n].get_intervallischer_abstand();
}

void einsatzschema::sortieren()
{
    int index_oberste_stimme;
    for(int i = 0; i < m_anzahl_stimmen - 1; i++)
    {
	index_oberste_stimme = i;
	for(int j = i + 1; j < m_anzahl_stimmen; j++)
	    if(m_die_stimmen[index_oberste_stimme] < m_die_stimmen[j])
		index_oberste_stimme = j;
	if(index_oberste_stimme != i)
	{
	    stimme hilfsstimme;
	    hilfsstimme = m_die_stimmen[i];
	    m_die_stimmen[i] = m_die_stimmen[index_oberste_stimme];
	    m_die_stimmen[index_oberste_stimme] = hilfsstimme;
	}
    }
}

int einsatzschema::get_max_abstand()
{
    int maxabstand = 0;
    for(int i = 0; i < m_anzahl_stimmen; i++)
	if(m_die_stimmen[i].get_rhythmischer_abstand() > maxabstand)
	    maxabstand = m_die_stimmen[i].get_rhythmischer_abstand();
    return maxabstand;
}

int einsatzschema::get_mitte()
{
    int hoechste_stimme;
    int tiefste_stimme;
    hoechste_stimme = tiefste_stimme = m_die_stimmen[0].get_intervallischer_abstand();
    for(int i = 1; i < m_anzahl_stimmen; i++)
	if(hoechste_stimme < m_die_stimmen[i].get_intervallischer_abstand())
	    hoechste_stimme = m_die_stimmen[i].get_intervallischer_abstand();
	else if(tiefste_stimme > m_die_stimmen[i].get_intervallischer_abstand())
	    tiefste_stimme = m_die_stimmen[i].get_intervallischer_abstand();
    return (hoechste_stimme + tiefste_stimme) / 2;
}
