// Copyright (C) 2012 Stefan Prey
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
// 
// 
// This file is part of kanonprogramme.
// 
// kanonprogramme is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// kanonprogramme is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with kanonprogramme.  If not, see <http://www.gnu.org/licenses/>.
// 
// Diese Datei ist Teil von kanonprogramme.
// 
// kanonprogramme ist Freie Software: Sie koennen es unter den Bedingungen
// der GNU General Public License, wie von der Free Software Foundation,
// Version 3 der Lizenz oder (nach Ihrer Option) jeder spaeteren
// veroeffentlichten Version, weiterverbreiten und/oder modifizieren.
// 
// kanonprogramme wird in der Hoffnung, dass es nuetzlich sein wird, aber
// OHNE JEDE GEWAEHELEISTUNG, bereitgestellt; sogar ohne die implizite
// Gewaehrleistung der MARKTFAEHIGKEIT oder EIGNUNG FUER EINEN BESTIMMTEN ZWECK.
// Siehe die GNU General Public License fuer weitere Details.
// 
// Sie sollten eine Kopie der GNU General Public License zusammen mit diesem
// Programm erhalten haben. Wenn nicht, siehe <http://www.gnu.org/licenses/>.
#include "StdAfx.h"
#include "knoten.h"

knoten::knoten()
{
    m_wert = 0;		    
    m_anzahl_adjazenzen = 0;
    m_adjazenzliste = 0; 
}

knoten::knoten(int wert, int anzahl_adjazenzen, const int* adjazenzliste)
{
    m_wert = wert;		    
    m_anzahl_adjazenzen = anzahl_adjazenzen;
// Das Folgende ist Unsinn

    m_adjazenzliste = new int [m_anzahl_adjazenzen];
    if(m_adjazenzliste == 0)
	exit(1);
    for(int i = 0; i < m_anzahl_adjazenzen; i++)
	m_adjazenzliste[i] = adjazenzliste[i];
}

knoten::~knoten()
{
    delete[] m_adjazenzliste;
}

knoten::knoten(const knoten& ausgangsknoten)
{
    m_wert = ausgangsknoten.m_wert;		    
    m_anzahl_adjazenzen = ausgangsknoten.m_anzahl_adjazenzen;
    m_adjazenzliste = new int [m_anzahl_adjazenzen];
    if(m_adjazenzliste == 0)
	exit(1);
    for(int i = 0; i < m_anzahl_adjazenzen; i++)
	m_adjazenzliste[i] = ausgangsknoten.m_adjazenzliste[i];
}

knoten& knoten::operator=(const knoten& kn)
{
// Zuweisung an sich selbst
    if(this == &kn)
	return *this;
    m_wert = kn.m_wert;		    
    m_anzahl_adjazenzen = kn.m_anzahl_adjazenzen;
    delete[] m_adjazenzliste;
    m_adjazenzliste = new int [m_anzahl_adjazenzen];
    if(m_adjazenzliste == 0)
	exit(1);
    for(int i = 0; i < m_anzahl_adjazenzen; i++)
	m_adjazenzliste[i] = kn.m_adjazenzliste[i];
    return *this;
}

